/* RevKit: A Toolkit for Reversible Circuit Design (www.revkit.org)
 * Copyright (C) 2009-2010  The RevKit Developers <revkit@informatik.uni-bremen.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "copy_metadata.hpp"

namespace revkit
{

  void copy_metadata( const circuit& base, circuit& circ )
  {
    circ.set_lines( base.lines() );
    circ.set_inputs( base.inputs () );
    circ.set_outputs( base.outputs() );
    circ.set_constants( base.constants() );
    circ.set_garbage( base.garbage() );
    circ.set_circuit_name( base.circuit_name() );
  }

}
