/* RevKit: A Toolkit for Reversible Circuit Design (www.revkit.org)
 * Copyright (C) 2009-2010  The RevKit Developers <revkit@informatik.uni-bremen.de>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "revlib_processor.hpp"

#include <iostream>

namespace revkit
{

  ////////////////////////////// class revlib_processor
  class revlib_processor::priv
  {
  public:
    std::vector<std::string> vars;
  };

  revlib_processor::revlib_processor()
    : d( new priv() )
  {
  }

  revlib_processor::~revlib_processor()
  {
    delete d;
  }

  void revlib_processor::on_comment( const std::string& comment ) const
  {
  }

  void revlib_processor::on_version( const std::string& version ) const
  {
  }

  void revlib_processor::on_numvars( unsigned numvars ) const
  {
  }

  void revlib_processor::on_variables( std::vector<std::string>::const_iterator first, std::vector<std::string>::const_iterator last ) const
  {
    std::copy( first, last, std::back_inserter( d->vars ) );
  }

  void revlib_processor::on_inputs( std::vector<std::string>::const_iterator first, std::vector<std::string>::const_iterator last ) const
  {
  }

  void revlib_processor::on_outputs( std::vector<std::string>::const_iterator first, std::vector<std::string>::const_iterator last ) const
  {
  }

  void revlib_processor::on_constants( std::vector<constant>::const_iterator first, std::vector<constant>::const_iterator last ) const
  {
  }

  void revlib_processor::on_garbage( std::vector<bool>::const_iterator first, std::vector<bool>::const_iterator last ) const
  {
  }

  void revlib_processor::on_begin() const
  {
  }

  void revlib_processor::on_end() const
  {
  }

  void revlib_processor::on_gate( const boost::any& target_type, const std::vector<unsigned>& line_indices ) const
  {
  }

  void revlib_processor::on_truth_table_line( unsigned line_index, const std::vector<boost::optional<bool> >::const_iterator first, const std::vector<boost::optional<bool> >::const_iterator last ) const
  {
  }

  const std::string& revlib_processor::variable( std::vector<std::string>::size_type index ) const
  {
    assert( index < d->vars.size() );

    return d->vars.at( index );
  }

}
