#!/bin/bash
LIBRARIES="boost-1.43.0 cudd-2.4.2 cuddread-0.1 puma-2.22 fmi-0.1"

MACHINE=`uname -m`

if [ $MACHINE = "i686" ]
then
    echo "Installing pre-compiled libraries and headers for $MACHINE architecture"
    for i in $LIBRARIES
    do
        if [[ $i != boost* || $1 == "1" ]]
        then
            wget http://www.informatik.uni-bremen.de/revkit/files/$i-$MACHINE.tar.gz
            tar xfz $i-$MACHINE.tar.gz
            rm $i-$MACHINE.tar.gz
        fi
    done

else

    echo "Source Code Installation for $MACHINE required"
    echo "This can take some minutes"

    if [[ $1 == "1" ]]
    then
        ./install_boost.sh
    fi
    ./install_cudd.sh
    ./install_cuddread.sh
    ./install_puma.sh
    ./install_fmi.sh

fi
